"""Test the utils.run_tidy function.

This doesn't test to see if tidy was actually run; all it does is make sure
that the function runs without error...
"""

from twill import utils
from twill.commands import config

bad_html = """<a href="test">you</a> <b>hello."""


def setup_module():
    config('require_tidy', 1)


def teardown_module():
    config('require_tidy', 0)


def test():
    (output, errors) = utils.run_tidy(bad_html)
    assert output is not None


def test2():
    config('require_tidy', 0)
    tidylib, utils.tidylib = utils.tidylib, None
    try:
        output, errors = utils.run_tidy(bad_html)
    finally:
        utils.tidylib = tidylib

    assert output is None
    assert errors is None
    config('require_tidy', 1)


def test3():
    tidylib, utils.tidylib = utils.tidylib, None
    try:
        try:
            utils.run_tidy(bad_html)
        except Exception:
            pass
        else:
            assert False, 'bad HTML should raise error'
    finally:
        utils.tidylib = tidylib


if __name__ == '__main__':
    setup_module()
    test()
    teardown_module()
